-- Krank Ya Radio, by Dezza: 6-8,15/7/2022 :) Happy Farming.

KrankYaRadio = {}

local modNamen = g_currentModName or "KrankYaHappyTunes"
local modDir = g_currentModDirectory or ""

function KrankYaRadio:new(mission)
	self.mission = mission

	self.settingsModel = g_settingsScreen.settingsModel

	self.gameSettings = self.settingsModel.gameSettings
	self.soundMixer = self.settingsModel.soundMixer

	self.modDirectory = modDir
	self.modNamen = modNamen

	self.input = g_inputBinding

	local settingsStuff = loadXMLFile("modDesc", self.modDirectory .. "modDesc.xml")
	self.title = getXMLString(settingsStuff, "modDesc.title.en")
	self.author = getXMLString(settingsStuff, "modDesc.author")
	self.version = getXMLString(settingsStuff, "modDesc.version")
	delete(settingsStuff)

	local defaultsStuff = loadXMLFile("defaults", self.modDirectory .. "settings/defaults.xml")
	self.targetAudioGroup = getXMLString(defaultsStuff, "defaults.targetAudioGroup")
	self.krankMaxVol = getXMLFloat(defaultsStuff, "defaults.krankMaxVol")
	self.krankIncrement = getXMLFloat(defaultsStuff, "defaults.krankIncrement")
	self.volumeMiddle = getXMLFloat(defaultsStuff, "defaults.volumeMiddle")
	delete(defaultsStuff);

	self.bindingsEnabled = false
	self.isEnabled = false

    return self
end

function KrankYaRadio:loadMap(name)
    Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, self.registerActionEvents);
	Player.removeActionEvents = Utils.appendedFunction(Player.removeActionEvents, self.removeActionEvents);
    Enterable.onRegisterActionEvents = Utils.appendedFunction(Enterable.onRegisterActionEvents, self.registerActionEvents);
end

function KrankYaRadio:onUpdate(dt)
end

function KrankYaRadio:changeRadioVolume(actionName, keyStatus, arg3, arg4, arg5)
   if( KrankYaRadio.bindingsEnabled ) then
		local currentVolume, newVolume = KrankYaRadio.gameSettings:getValue('radioVolume')

		if( actionName == "KYR_RADIO_VOLUME_UP" ) then
			newVolume = currentVolume + KrankYaRadio.krankIncrement
			if( newVolume > KrankYaRadio.krankMaxVol ) then
				newVolume = KrankYaRadio.krankMaxVol
			end
		elseif( actionName == "KYR_RADIO_VOLUME_DOWN" ) then
			newVolume = currentVolume - KrankYaRadio.krankIncrement
			if( newVolume < 0 ) then
				newVolume = 0
			end
		end

		KrankYaRadio.gameSettings:setValue('radioVolume',newVolume)
		local audioGroupIndex = AudioGroup.getAudioGroupIndexByName(KrankYaRadio.targetAudioGroup)
		KrankYaRadio.soundMixer:setAudioGroupVolumeFactor(audioGroupIndex, newVolume)
 	end
end

function KrankYaRadio:registerActionEvents()
	local _, actionEventVolUpId = g_inputBinding:registerActionEvent('KYR_RADIO_VOLUME_UP', InputBinding.NO_EVENT_TARGET, KrankYaRadio.changeRadioVolume, false, true, false, true)
	KrankYaRadio.actionEventVolUpId = actionEventVolUpId
	g_inputBinding:setActionEventTextVisibility(actionEventVolUpId, false)

	local _, actionEventVolDownId = g_inputBinding:registerActionEvent('KYR_RADIO_VOLUME_DOWN', InputBinding.NO_EVENT_TARGET, KrankYaRadio.changeRadioVolume, false, true, false, true)
	KrankYaRadio.actionEventVolDownId = actionEventVolDownId
	g_inputBinding:setActionEventTextVisibility(actionEventVolDownId, false)

	KrankYaRadio.bindingsEnabled = true
end

function KrankYaRadio:removeActionEvents()
	g_inputBinding:removeActionEvent(KrankYaRadio.actionEventVolUpId);
	g_inputBinding:removeActionEvent(KrankYaRadio.actionEventVolDownId);
end;

local krankenItUpEnv

--[[ Get it all Kranken' !! ]]
local function load(mission)
    assert(g_krankYaRadio == nil)

    krankenItUpEnv = KrankYaRadio:new(mission)

    getfenv(0)["g_krankYaRadio"] = krankenItUpEnv

    addModEventListener(krankenItUpEnv)
end

--[[ And totally chilled ]]
local function unload()
    removeModEventListener(KrankYaRadio)
    krankenItUpEnv = nil --[[ taken' out the trash ... ]]

    getfenv(0)["g_krankYaRadio"] = nil
end

local function init()
    FSBaseMission.delete = Utils.appendedFunction(FSBaseMission.delete, unload)

    Mission00.load = Utils.prependedFunction(Mission00.load, load)
end

init()

